<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Personal/Challenges/Haskell/extra_long_factorial.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum>1: </span><a class=annot href="#"><span class=annottext>GHC.Types.Module</span><span class='hs-keyword'>module</span></a> <span class='hs-conid'>Main</span> <span class='hs-keyword'>where</span>
<span class=hs-linenum>2: </span>
<span class=hs-linenum>3: </span><a class=annot href="#"><span class=annottext>(GHC.Num.Num a, GHC.Classes.Ord a) =&gt; a -&gt; a</span><span class='hs-definition'>factorial</span></a> <a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>n</span></a>  
<span class=hs-linenum>4: </span>  <span class='hs-keyglyph'>|</span> <a class=annot href="#"><span class=annottext>GHC.Types.Bool</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {v : GHC.Types.Bool | v &lt;=&gt; x1 &lt; x2}</span><span class='hs-varop'>&lt;</span></a> <span class='hs-num'>1</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : GHC.Integer.Type.Integer | v == 1}</span><span class='hs-num'>1</span></a>
<span class=hs-linenum>5: </span>  <span class='hs-keyglyph'>|</span> <span class='hs-varid'>otherwise</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{VV : a | VV == n}</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {VV : a | VV == x1 * x2}</span><span class='hs-varop'>*</span></a> <a class=annot href="#"><span class=annottext>(GHC.Num.Num a, GHC.Classes.Ord a) =&gt; a -&gt; a</span><span class='hs-varid'>factorial</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {VV : a | VV == x1 - x2}</span><span class='hs-comment'>-</span></a> <span class='hs-num'>1</span><span class='hs-layout'>)</span>
<span class=hs-linenum>6: </span>
<span class=hs-linenum>7: </span><a class=annot href="#"><span class=annottext>(GHC.Types.IO ())</span><span class='hs-definition'>main</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>8: </span>    <a class=annot href="#"><span class=annottext>GHC.Integer.Type.Integer</span><span class='hs-varid'>n</span></a> <span class='hs-keyglyph'>&lt;-</span> <a class=annot href="#"><span class=annottext>(GHC.Types.IO GHC.Integer.Type.Integer)</span><span class='hs-varid'>readLn</span></a> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>IO</span> <span class='hs-conid'>Integer</span>
<span class=hs-linenum>9: </span>    <a class=annot href="#"><span class=annottext>GHC.Integer.Type.Integer -&gt; (GHC.Types.IO ())</span><span class='hs-varid'>print</span></a> <span class='hs-varop'>$</span> <a class=annot href="#"><span class=annottext>GHC.Integer.Type.Integer -&gt; GHC.Integer.Type.Integer</span><span class='hs-varid'>factorial</span></a> <span class='hs-varid'>n</span>
</pre>
</body>
</html>